% paper example
toy_example(sst(
			0, 0,
			state(	[
				p([															% principal 'f1'
					ps( rule(sc(2,1,[var(x),b]), var(x)),
						p([
							ps( rule(sym_enc(var(y),k), var(y)),
								p([
									ps( rule(a, c1), p([]) ),								% f4
									ps( rule(var(x), c2), p([]) ),							% f5
									ps( rule(var(y), c2), p([]) )							% f6
								])
							)
						])
					)
				]),
				p([															% principal 'g1'
					ps( rule(epsilon, sc(2,1,[a,b])), p([])),				 % g2
					ps( rule(epsilon, sc(2,1,[b,b])), p([]))				 % g3
				])
			],
		[sym_enc(a,k), sym_enc(b,k)],			% inital intruder knowledge
		[]),root,root,[],nn,nn,[])).


/*asw_alice_newsig(sst(0, 0, state([
			% Alice
			p([
				ps(rule(epsilon, M1A), p([
						ps(rule(M2A, nonceA), p([
							ps(rule(M4, acpt_std_contract), p([])),
							ps(rule(epsilon, sc(a,t,RESOLVE_MSG_A)), p([
								ps(rule(sc(t,a,ABORT_TOKEN), aborted), p([])),
								ps(rule(sc(t,a,RESOLVE_TOKEN), resolved), p([]))
							]))
						])),
						ps(rule(epsilon, sc(a,t,ABORT_MSG_A)), p([
							ps(rule(sc(t,a,RESOLVE_TOKEN), resolved), p([])),
							ps(rule(sc(t,a,ABORT_TOKEN), aborted), p([]))
						]))
				])),
				ps(rule(epsilon, do_nothing), p([]))
			]),
			% trusted party
			p([
				ps(rule(sc(a,t,ABORT_MSG), sc(t,a,ABORT_TOKEN)), p([
					ps(rule(RESOLVE_MSG_B, ABORT_TOKEN), p([]))
				])),
				ps(rule(RESOLVE_MSG_B, RESOLVE_TOKEN), p([
					ps(rule(sc(a,t,RESOLVE_MSG_A), sc(t,a,RESOLVE_TOKEN)), p([])),
					ps(rule(sc(a,t,ABORT_MSG), sc(t,a,RESOLVE_TOKEN)), p([]))
				])),
				ps(rule(sc(a,t,RESOLVE_MSG_A), sc(t,a,RESOLVE_TOKEN)), p([
					ps(rule(RESOLVE_MSG_B, RESOLVE_TOKEN), p([]))
				]))
			]),
			p([
				ps(rule(M_STD_FINAL, intruder_has_std_contract), p([])),
				ps(rule(M_RSLV_FINAL, intruder_has_rslv_contract), p([]))
			])
		],
		% initial params
		 [pkA,pkB, e],[]),
		% [nonceA, pkA, pkB, sc_key_0,skB,skA,skT,nonceA, var(randA,526),var(randB,526),var(randB,521),var(randA,502),var(randA,468),var(randA)],[]),
		root,root,[],nn,nn,[])
	) :-
        M1A = [ [pkA,pkB,t,text,hash(nonceA)],		sig([pkA,pkB,t,text,hash(nonceA)],pk(skA))	   ],
        %M2A = [ [M1A, hash(var(randB))],			sig([M1A, hash(var(randB))],pk(e))			   ],
        M2A = [M1A, hash(var(randB))],
		M1 =  [ [pkA,pkB,t,text,hash(var(randA))],	sig([pkA,pkB,t,text,hash(var(randA))],pk(skA)) ],
		%M2 =  [ [M1, hash(var(randB))],				sig([M1, hash(var(randB))],pk(e))			   ],
		M2 =  [M1, hash(var(randB))],
		M3 = nonceA,
		M4 = var(randB),
		ABORT_MSG = [ [abort, M1], sig([abort, M1],pk(skA)) ],
		ABORT_MSG_A = [ [abort, M1A], sig([abort, M1A],pk(skA)) ],
		ABORT_TOKEN = [ [abort, ABORT_MSG], sig([abort, ABORT_MSG],pk(skT)) ],
		RESOLVE_MSG_A = [[M1, M2], sig([M1, M2],pk(skA))],
		%RESOLVE_MSG_B = [[M1, M2], sig([M1, M2],pk(e))],
		RESOLVE_MSG_B = [M1, M2],
		RESOLVE_TOKEN = [[M1, M2], sig([M1, M2],pk(skT))],
		M_STD_FINAL = [M2, M3, M4],
		M_RSLV_FINAL = [[M1, M2], sig([M1, M2], pk(skT))].*/


%%%%%%%%%%%% Hones Alice %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
asw_alice_simple(sst(0, 0, state([
			% Alice
			p([
				ps(rule(epsilon, M1A), p([
						ps(rule(M2A, nonceA), p([
							ps(rule(M4, alice_has_contract), p([])),
							ps(rule(epsilon, sc(a,t,RESOLVE_MSG_A)), p([
								ps(rule(sc(t,a,RESOLVE_TOKEN), alice_has_contract), p([]))
							]))
						])),
						ps(rule(epsilon, sc(a,t,ABORT_MSG_A)), p([
							ps(rule(sc(t,a,RESOLVE_TOKEN), alice_has_contract), p([])),
							ps(rule(sc(t,a,ABORT_TOKEN), aborted), p([]))
						]))
				])),
				ps(rule(epsilon, do_nothing), p([]))
			]),
			% trusted party
			p([
				ps(rule(sc(a,t,ABORT_MSG), sc(t,a,ABORT_TOKEN)), p([
					ps(rule(RESOLVE_MSG_B, ABORT_TOKEN), p([]))
				])),
				ps(rule(RESOLVE_MSG_B, RESOLVE_TOKEN), p([
					ps(rule(sc(a,t,RESOLVE_MSG_A), sc(t,a,RESOLVE_TOKEN)), p([])),
					ps(rule(sc(a,t,ABORT_MSG), sc(t,a,RESOLVE_TOKEN)), p([]))
				])),
				ps(rule(sc(a,t,RESOLVE_MSG_A), sc(t,a,RESOLVE_TOKEN)), p([
					ps(rule(RESOLVE_MSG_B, RESOLVE_TOKEN), p([]))
				]))
			]),
			p([
				ps(rule(M_STD_FINAL, intruder_has_contract), p([])),
			  	ps(rule(M_RSLV_FINAL, intruder_has_contract), p([]))
			])
		],
		% initial params
		 [pkA,pkB, e, t, abort, text],[]),
		root,root,[],nn,nn,[])
	) :-
        M1A = [ [pkA,pkB,t,text,hash(nonceA)],		sig([pkA,pkB,t,text,hash(nonceA)],pk(skA))	   ],
        M2A = [M1A, hash(var(randB))],
		M1 =  [ [pkA,pkB,t,text,hash(var(randA))],	sig([pkA,pkB,t,text,hash(var(randA))],pk(skA)) ],
		M2 =  [M1, hash(var(randB))],
		M3 = nonceA,
		M4 = var(randB),
		ABORT_MSG = sig([abort, M1],pk(skA)),
		ABORT_MSG_A = sig([abort, M1A],pk(skA)),
		ABORT_TOKEN = sig([abort, ABORT_MSG],pk(skT)),
		RESOLVE_MSG_A = sig([M1, M2],pk(skA)),
		RESOLVE_MSG_B = [M1, M2],
		RESOLVE_TOKEN = sig([M1, M2],pk(skT)),
		M_STD_FINAL = [M2, M3, M4],
		M_RSLV_FINAL = sig([M1, M2], pk(skT)).

%%%%%%%%%%%% Hones Bob %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
asw_bob(sst(0, 0, state([
			% Bob
			p([
				ps(rule(M1, M2), p([
					ps(rule(M3, M4), p([
						ps(rule(epsilon, bob_has_contract), p([])),
						ps(rule(epsilon, sc(b,t,RESOLVE_MSG_B)), p([
							ps(rule(sc(t,b,ABORT_TOKEN), aborted), p([])),
							ps(rule(sc(t,b,RESOLVE_TOKEN), bob_has_contract), p([]))
						]))
					]))
				])),
				ps(rule(epsilon, do_nothing), p([]))
			]),
			% trusted party
			p([
				ps(rule(ABORT_MSG, ABORT_TOKEN), p([
					ps(rule(sc(b,t,RESOLVE_MSG_B), sc(t,b,ABORT_TOKEN)), p([]))
				])),
				ps(rule(sc(b,t,RESOLVE_MSG_B), sc(t,b,RESOLVE_TOKEN)), p([
					ps(rule(RESOLVE_MSG_A, RESOLVE_TOKEN), p([])),
					ps(rule(ABORT_MSG, RESOLVE_TOKEN), p([]))
				])),
				ps(rule(RESOLVE_MSG_A, RESOLVE_TOKEN), p([
					ps(rule(sc(b,t,RESOLVE_MSG_B), sc(t,b,RESOLVE_TOKEN)), p([]))
				]))
			]),
			p([
				ps(rule(M_STD_FINAL, intruder_has_contract), p([])),
			  	ps(rule(M_RSLV_FINAL, intruder_has_contract), p([]))
			])
		],
		% initial params
		[pkA,pkB,skB, e, t, abort, text],[]),
		root,root,[],nn,nn,[])
	) :-
		M1B = [ [pkA,pkB,t,text,hash(var(randA))], sig(pkA,pkB,t,text,hash(var(randA)), pk(skA)) ],
		M1 =  [ [pkA,pkB,t,text,hash(var(randA))], sig(pkA,pkB,t,text,hash(var(randA)), pk(skA)) ],
		M2B = [ [M1B, hash(nonceB)], sig([M1B, hash(nonceB)], pk(skB)) ],
		M2 =  sig([M1, hash(nonceB)], pk(skB)),
		M3 =  var(randA),
		M4 =  nonceB,
		ABORT_MSG = sig([abort, M1], pk(skA)),
		ABORT_TOKEN = sig([abort, ABORT_MSG], pk(skT)),
		RESOLVE_MSG_A = sig([M1, M2], pk(skA)),
		RESOLVE_MSG_B = sig([M1, M2], pk(skB)),
		RESOLVE_TOKEN = sig([M1,M2], pk(skT)),
		M_STD_FINAL = [M2, M3, M4],
		M_RSLV_FINAL = sig([M1, M2], pk(skT)).



